var palette = [
"#0000d0", "#00d000", "#d00000", "#d0d000", "#d000d0", "#00d0d0",
"#8000d0", "#80d000", "#d08000", "#d0d080", "#d080d0", "#80d0d0",
"#0080d0", "#00d080", "#d00080",
"#4000d0", "#40d000", "#d04000", "#d0d040", "#d040d0", "#40d0d0",
"#4080d0", "#40d080", "#d40080",
];

function _naviTo(lX, lY)
{
  Sdk.Position.SetPosition(lY/100000, lX/100000);
}

function _getJunctions()
{
  Sdk.Navigation.GetJunctions().then(junctions =>
  {
    g.logClear();
    for (var i in junctions)
    {
      var j = junctions[i];
      g.log(j.m_cbJunctionInfo + " / " + j.m_cbJunctionType + " <input type=button value='go' onClick='_naviTo("+j.m_Position.lX+","+j.m_Position.lY+")'>");
    }
  });
}

function _getRoads()
{
  var curPos = map.getCenter();
  var d = 0.003; //200/100000;
  _globalList = [];
  _globalListResolve = [];
  _globalListTimer = null;

  var rect =
  [[curPos.lng()+d, curPos.lat()-d],
   [curPos.lng()-d, curPos.lat()-d],
   [curPos.lng()-d, curPos.lat()+d],
   [curPos.lng()+d, curPos.lat()+d],
   [curPos.lng()+d, curPos.lat()-d]
  ]; 

  g.drawClear();
  g.drawPolygon({id:"getroadrect", color:'#d0d0ff', alpha:0.1, geometry:rect});

  Sdk.MapReader.GetRoads(curPos.lat()+d, curPos.lng()-d, curPos.lat()-d, curPos.lng()+d)
    .then(list => {
      if (!list)
        return; // problem!
      _globalList = list;
      _globalBusy = false;
      if (!_globalListTimer)
        _globalListTimer = setInterval(()=>
          {
            if (_globalBusy)
              return;

            if (_globalList.length == 0)
            {
              clearInterval(_globalListTimer);
              delete _globalListTimer;
              return;
            }

            var current = _globalList.shift();
            _globalListResolve.push(current);
            _globalBusy = true;
            Sdk.MapReader.GetRoad(current)
            .then(roadinfo => 
              { 
                _globalBusy = false;
                var c = _globalListResolve.shift();
                g.drawPolyline({id:c.iso + "_" + c.id, color:palette[Math.floor(Math.random()*palette.length)], alpha:1, geometry:roadinfo.geometry}); 
              })
          }, 10);
    } );
}

function _quickRoute(r)
{
  var latlon = (s) =>
  {
    s = s.split(" ").join("");
    s = s.split(",");
    return {lat:parseFloat(s[0]), lng:parseFloat(s[1])};
  }

  var points = r.split(";");
  for (var i in points)
  {
    points[i] = latlon(points[i]);
  }
  Sdk.Route.Set(points);
}

function _getMaps()
{
  _globalList = [];
  _globalListResolve = [];
  _globalListTimer = null;

  GetMapsIteration = function()
  {
    if (_globalList.length == 0)
      return _globalListResolve;
    
    var first = _globalList.shift();
    return Sdk.MapLoader.GetMap(first)
    .then(info=>
    {
      _globalListResolve.push(info);
    })
    .then(GetMapsIteration);
  }

  return Sdk.MapLoader.GetMapsCount()
    .then(count =>
    {
      for (var i=0; i<count; i++)
        _globalList.push(i);
    })
    .then(GetMapsIteration);
}

function _getMapList()
{
  _getMaps().then(maps => {
    var html = "";
    for (var i=0; i<maps.length; i++)
    {
      var map = maps[i];
      html += [map.nIndex, map.strIso, "<a href='' title='"+map.header+"'>" + map.strPath + "</a>", map.format].join(", ") + "<br>";
    }
    g.loghtml(html);
  });
}