
// ------- ATTRIBUTES (VERTEX BUFFER DATA) -------
attribute vec4		a_vPosition0;
attribute vec2		a_vTexCoord0;
attribute vec3		a_vTexCoord1;

// ------- UNIFORMS (SHADER CONSTS) -------
uniform mat4		hu_mPMVMatrix;
uniform mat4		hu_mMMatrix;
uniform vec3		hu_vNormalizedViewDir;
uniform vec3		hu_vCameraPos;
uniform vec4		hu_vCameraNearFar;
uniform float		hu_fSin11; // debug
uniform vec2		u_vTextureUVScale;
uniform float		u_fWidth;

// ------- INTERPOLATORS (SHADER OUTPUTS) -------
varying vec2		v_vTex0UV;

void main(void)
{
	v_vTex0UV = a_vTexCoord0*u_vTextureUVScale;

	vec4 vPos = a_vPosition0;
	vec3 vShift = a_vTexCoord1;
	vPos.xyz += u_fWidth*vShift;
	
	gl_Position = hu_mPMVMatrix*vPos;
}
